/* ==== posix.h ============================================================
 * Based on the freebsd version written by Chris Provenzo
 * Copyright (c) 1993 Chris Provenzano, proven@mit.edu
 *
 * Modified by Herve Avril, for NEXTSTEP
 * Copyright (c) 1996 Hutchison Avenue Software, herve@hasc.ca
 *
 * posix-nextstep3.h, v1.0a Januaray 1996
 *
 */

#ifndef _PTHREAD_POSIX_H_
#define _PTHREAD_POSIX_H_

#include <sys/cdefs.h>
#include <bsd/sys/stat.h>

/* More stuff for compiling */
#if defined(__GNUC__)
#define __INLINE                extern inline
#else
#define __INLINE                static
#endif

/* Make sure we have size_t defined */
#include <pthread/types.h>

#define S_IRUSR	_S_IRUSR	/* read permission, owner */
#define S_IRGRP	0000040		/* read permission, group */
#define S_IROTH	0000004		/* read permission, other */
#define S_IWUSR	_S_IWUSR	/* write permission, owner */
#define S_IWGRP	0000020		/* write permission, group */
#define S_IWOTH	0000002		/* write permission, other */
#define S_IXUSR	_S_IXUSR	/* execute/search permission, */
				/* owner */
#define S_IXGRP	0000010		/* execute/search permission, */
				/* group */
#define S_IXOTH	0000001		/* execute/search permission, */
				/* other */
#define S_IRWXU	0000700		/* read, write, execute */
				/* permissions, owner */
#define S_IRWXG	0000070		/* read, write, execute */
				/* permissions, group */
#define S_IRWXO	0000007		/* read, write, execute */
				/* permissions, other */

#define S_ISBLK(mode)	(((mode) & (_S_IFMT)) == (_S_IFBLK))
#define S_ISCHR(mode)	(((mode) & (_S_IFMT)) == (_S_IFCHR))
#define S_ISDIR(mode)	(((mode) & (_S_IFMT)) == (_S_IFDIR))
#define S_ISFIFO(mode)	(((mode) & (_S_IFMT)) == (_S_IFIFO))
#define S_ISREG(mode)	(((mode) & (_S_IFMT)) == (_S_IFREG))

#ifndef __WAIT_STATUS
#define __WAIT_STATUS	int *
#endif

#endif

