/* ==== syscall.S ============================================================
 * Based on the freebsd version written by Chris Provenzo
 * Copyright (c) 1990 The Regents of the University of California.
 * Copyright (c) 1995 Chris Provenzano, proven@mit.edu
 *
 * Modified by Herve Avril, for NEXTSTEP
 * Copyright (c) 1996 Hutchison Avenue Software, herve@hasc.ca
 *
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the University of
 *	California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * Description : Machine dependent syscalls for m68k
 *
 * syscall-m68k-nextstep3.S, v1.0a, January 1996
 *
 */

#include <bsd/syscall.h> 

	.text
	.align	2

_machdep_no_error:	
	moveml sp@+,d2-d6
	rts

_machdep_error:
	movel	d0,_errno
	negl	d0
	rts
	
	.globl	_machdep_sys_exit

_machdep_sys_exit:
	moveal sp,a0
	movel #1,d0
	moveml d2-d6,sp@-
	movel a0@(4),d1
	movel a0@(8),d2
	movel a0@(12),d3
	movel a0@(16),d4
	movel a0@(20),d5
	movel a0@(24),d6
	.byte 0x4e
	.byte 0x44
	bcc _machdep_no_error
	bsr _machdep_error
	moveml sp@+,d2-d6
	rts

	.globl	_machdep_sys_unlink
	
_machdep_sys_unlink:
	moveal sp,a0
	movel #10,d0
	moveml d2-d6,sp@-
	movel a0@(4),d1
	movel a0@(8),d2
	movel a0@(12),d3
	movel a0@(16),d4
	movel a0@(20),d5
	movel a0@(24),d6
	.byte 0x4e
	.byte 0x44
	bcc _machdep_no_error
	bsr _machdep_error
	moveml sp@+,d2-d6
	rts

	.globl	_machdep_sys_fchmod
	
_machdep_sys_fchmod:
	moveal sp,a0
	movel #124,d0
	moveml d2-d6,sp@-
	movel a0@(4),d1
	movel a0@(8),d2
	movel a0@(12),d3
	movel a0@(16),d4
	movel a0@(20),d5
	movel a0@(24),d6
	.byte 0x4e
	.byte 0x44
	bcc _machdep_no_error
	bsr _machdep_error
	moveml sp@+,d2-d6
	rts

	.globl	_machdep_sys_chdir
	
_machdep_sys_chdir:
	moveal sp,a0
	movel #12,d0
	moveml d2-d6,sp@-
	movel a0@(4),d1
	movel a0@(8),d2
	movel a0@(12),d3
	movel a0@(16),d4
	movel a0@(20),d5
	movel a0@(24),d6
	.byte 0x4e
	.byte 0x44
	bcc _machdep_no_error
	bsr _machdep_error
	moveml sp@+,d2-d6
	rts

	.globl	_machdep_sys_chmod
	
_machdep_sys_chmod:
	moveal sp,a0
	movel #15,d0
	moveml d2-d6,sp@-
	movel a0@(4),d1
	movel a0@(8),d2
	movel a0@(12),d3
	movel a0@(16),d4
	movel a0@(20),d5
	movel a0@(24),d6
	.byte 0x4e
	.byte 0x44
	bcc _machdep_no_error
	bsr _machdep_error
	moveml sp@+,d2-d6
	rts

	.globl	_machdep_sys_chown
	
_machdep_sys_chown:
	moveal sp,a0
	movel #16,d0
	moveml d2-d6,sp@-
	movel a0@(4),d1
	movel a0@(8),d2
	movel a0@(12),d3
	movel a0@(16),d4
	movel a0@(20),d5
	movel a0@(24),d6
	.byte 0x4e
	.byte 0x44
	bcc _machdep_no_error
	bsr _machdep_error
	moveml sp@+,d2-d6
	rts

	.globl	_machdep_sys_recvmsg
	
_machdep_sys_recvmsg:
	moveal sp,a0
	movel #113,d0
	moveml d2-d6,sp@-
	movel a0@(4),d1
	movel a0@(8),d2
	movel a0@(12),d3
	movel a0@(16),d4
	movel a0@(20),d5
	movel a0@(24),d6
	.byte 0x4e
	.byte 0x44
	bcc _machdep_no_error
	bsr _machdep_error
	moveml sp@+,d2-d6
	rts

	.globl	_machdep_sys_sendmsg
	
_machdep_sys_sendmsg:
	moveal sp,a0
	movel #114,d0
	moveml d2-d6,sp@-
	movel a0@(4),d1
	movel a0@(8),d2
	movel a0@(12),d3
	movel a0@(16),d4
	movel a0@(20),d5
	movel a0@(24),d6
	.byte 0x4e
	.byte 0x44
	bcc _machdep_no_error
	bsr _machdep_error
	moveml sp@+,d2-d6
	rts

	.globl	_machdep_sys_shutdown
	
_machdep_sys_shutdown:
	moveal sp,a0
	movel #134,d0
	moveml d2-d6,sp@-
	movel a0@(4),d1
	movel a0@(8),d2
	movel a0@(12),d3
	movel a0@(16),d4
	movel a0@(20),d5
	movel a0@(24),d6
	.byte 0x4e
	.byte 0x44
	bcc _machdep_no_error
	bsr _machdep_error
	moveml sp@+,d2-d6
	rts

	.globl	_machdep_sys_rename
	
_machdep_sys_rename:
	moveal sp,a0
	movel #128,d0
	moveml d2-d6,sp@-
	movel a0@(4),d1
	movel a0@(8),d2
	movel a0@(12),d3
	movel a0@(16),d4
	movel a0@(20),d5
	movel a0@(24),d6
	.byte 0x4e
	.byte 0x44
	bcc _machdep_no_error
	bsr _machdep_error
	moveml sp@+,d2-d6
	rts

	.globl	_machdep_sys_link
	
_machdep_sys_link:
	moveal sp,a0
	movel #9,d0
	moveml d2-d6,sp@-
	movel a0@(4),d1
	movel a0@(8),d2
	movel a0@(12),d3
	movel a0@(16),d4
	movel a0@(20),d5
	movel a0@(24),d6
	.byte 0x4e
	.byte 0x44
	bcc _machdep_no_error
	bsr _machdep_error
	moveml sp@+,d2-d6
	rts

	.globl	_machdep_sys_stat
	
_machdep_sys_stat:
	moveal sp,a0
	movel #38,d0
	moveml d2-d6,sp@-
	movel a0@(4),d1
	movel a0@(8),d2
	movel a0@(12),d3
	movel a0@(16),d4
	movel a0@(20),d5
	movel a0@(24),d6
	.byte 0x4e
	.byte 0x44
	bcc _machdep_no_error
	bsr _machdep_error
	moveml sp@+,d2-d6
	rts

	.globl	_machdep_sys_fchown
	
_machdep_sys_fchown:
	moveal sp,a0
	movel #123,d0
	moveml d2-d6,sp@-
	movel a0@(4),d1
	movel a0@(8),d2
	movel a0@(12),d3
	movel a0@(16),d4
	movel a0@(20),d5
	movel a0@(24),d6
	.byte 0x4e
	.byte 0x44
	bcc _machdep_no_error
	bsr _machdep_error
	moveml sp@+,d2-d6
	rts

	.globl	_machdep_sys_read
	
_machdep_sys_read:
	moveal sp,a0
	movel #3,d0
	moveml d2-d6,sp@-
	movel a0@(4),d1
	movel a0@(8),d2
	movel a0@(12),d3
	movel a0@(16),d4
	movel a0@(20),d5
	movel a0@(24),d6
	.byte 0x4e
	.byte 0x44
	bcc _machdep_no_error
	bsr _machdep_error
	moveml sp@+,d2-d6
	rts

	.globl	_machdep_sys_write
	
_machdep_sys_write:
	moveal sp,a0
	movel #4,d0
	moveml d2-d6,sp@-
	movel a0@(4),d1
	movel a0@(8),d2
	movel a0@(12),d3
	movel a0@(16),d4
	movel a0@(20),d5
	movel a0@(24),d6
	.byte 0x4e
	.byte 0x44
	bcc _machdep_no_error
	bsr _machdep_error
	moveml sp@+,d2-d6
	rts

	.globl	_machdep_sys_open
	
_machdep_sys_open:
	moveal sp,a0
	movel #5,d0
	moveml d2-d6,sp@-
	movel a0@(4),d1
	movel a0@(8),d2
	movel a0@(12),d3
	movel a0@(16),d4
	movel a0@(20),d5
	movel a0@(24),d6
	.byte 0x4e
	.byte 0x44
	bcc _machdep_no_error
	bsr _machdep_error
	moveml sp@+,d2-d6
	rts

	.globl	_machdep_sys_close
	
_machdep_sys_close:
	moveal sp,a0
	movel #6,d0
	moveml d2-d6,sp@-
	movel a0@(4),d1
	movel a0@(8),d2
	movel a0@(12),d3
	movel a0@(16),d4
	movel a0@(20),d5
	movel a0@(24),d6
	.byte 0x4e
	.byte 0x44
	bcc _machdep_no_error
	bsr _machdep_error
	moveml sp@+,d2-d6
	rts

	.globl	_machdep_sys_lseek
	
_machdep_sys_lseek:
	moveal sp,a0
	movel #19,d0
	moveml d2-d6,sp@-
	movel a0@(4),d1
	movel a0@(8),d2
	movel a0@(12),d3
	movel a0@(16),d4
	movel a0@(20),d5
	movel a0@(24),d6
	.byte 0x4e
	.byte 0x44
	bcc _machdep_no_error
	bsr _machdep_error
	moveml sp@+,d2-d6
	rts

	.globl	_machdep_sys_fcntl
	
_machdep_sys_fcntl:
	moveal sp,a0
	movel #92,d0
	moveml d2-d6,sp@-
	movel a0@(4),d1
	movel a0@(8),d2
	movel a0@(12),d3
	movel a0@(16),d4
	movel a0@(20),d5
	movel a0@(24),d6
	.byte 0x4e
	.byte 0x44
	bcc _machdep_no_error
	bsr _machdep_error
	moveml sp@+,d2-d6
	rts

	.globl	_machdep_sys_dup2
	
_machdep_sys_dup2:
	moveal sp,a0
	movel #90,d0
	moveml d2-d6,sp@-
	movel a0@(4),d1
	movel a0@(8),d2
	movel a0@(12),d3
	movel a0@(16),d4
	movel a0@(20),d5
	movel a0@(24),d6
	.byte 0x4e
	.byte 0x44
	bcc _machdep_no_error
	bsr _machdep_error
	moveml sp@+,d2-d6
	rts

	.globl	_machdep_sys_readv
	
_machdep_sys_readv:
	moveal sp,a0
	movel #120,d0
	moveml d2-d6,sp@-
	movel a0@(4),d1
	movel a0@(8),d2
	movel a0@(12),d3
	movel a0@(16),d4
	movel a0@(20),d5
	movel a0@(24),d6
	.byte 0x4e
	.byte 0x44
	bcc _machdep_no_error
	bsr _machdep_error
	moveml sp@+,d2-d6
	rts

	.globl	_machdep_sys_writev
	
_machdep_sys_writev:
	moveal sp,a0
	movel #121,d0
	moveml d2-d6,sp@-
	movel a0@(4),d1
	movel a0@(8),d2
	movel a0@(12),d3
	movel a0@(16),d4
	movel a0@(20),d5
	movel a0@(24),d6
	.byte 0x4e
	.byte 0x44
	bcc _machdep_no_error
	bsr _machdep_error
	moveml sp@+,d2-d6
	rts

	.globl	_machdep_sys_fstat
	
_machdep_sys_fstat:
	moveal sp,a0
	movel #62,d0
	moveml d2-d6,sp@-
	movel a0@(4),d1
	movel a0@(8),d2
	movel a0@(12),d3
	movel a0@(16),d4
	movel a0@(20),d5
	movel a0@(24),d6
	.byte 0x4e
	.byte 0x44
	bcc _machdep_no_error
	bsr _machdep_error
	moveml sp@+,d2-d6
	rts

	.globl	_machdep_sys_dup	
	
_machdep_sys_dup	:
	moveal sp,a0
	movel #41,d0
	moveml d2-d6,sp@-
	movel a0@(4),d1
	movel a0@(8),d2
	movel a0@(12),d3
	movel a0@(16),d4
	movel a0@(20),d5
	movel a0@(24),d6
	.byte 0x4e
	.byte 0x44
	bcc _machdep_no_error
	bsr _machdep_error
	moveml sp@+,d2-d6
	rts

	.globl	_machdep_sys_pipe
	
_machdep_sys_pipe:
	moveal sp,a0
	movel #42,d0
	moveml d2-d6,sp@-
	movel a0@(4),d1
	movel a0@(8),d2
	movel a0@(12),d3
	movel a0@(16),d4
	movel a0@(20),d5
	movel a0@(24),d6
	.byte 0x4e
	.byte 0x44
	bcc _machdep_no_error
	bsr _machdep_error
	moveml sp@+,d2-d6
	rts

	.globl	_machdep_sys_fork
	
_machdep_sys_fork:
	moveal sp,a0
	movel #2,d0
	moveml d2-d6,sp@-
	movel a0@(4),d1
	movel a0@(8),d2
	movel a0@(12),d3
	movel a0@(16),d4
	movel a0@(20),d5
	movel a0@(24),d6
	.byte 0x4e
	.byte 0x44
	bcc _machdep_no_error
	bsr _machdep_error
	moveml sp@+,d2-d6
	rts

	.globl	_machdep_sys_execve
	
_machdep_sys_execve:
	moveal sp,a0
	movel #59,d0
	moveml d2-d6,sp@-
	movel a0@(4),d1
	movel a0@(8),d2
	movel a0@(12),d3
	movel a0@(16),d4
	movel a0@(20),d5
	movel a0@(24),d6
	.byte 0x4e
	.byte 0x44
	bcc _machdep_no_error
	bsr _machdep_error
	moveml sp@+,d2-d6
	rts

	.globl	_machdep_sys_wait3
	
_machdep_sys_wait3:
	moveal sp,a0
	movel #171,d0
	moveml d2-d6,sp@-
	movel a0@(4),d1
	movel a0@(8),d2
	movel a0@(12),d3
	movel a0@(16),d4
	movel a0@(20),d5
	movel a0@(24),d6
	.byte 0x4e
	.byte 0x44
	bcc _machdep_no_error
	bsr _machdep_error
	moveml sp@+,d2-d6
	rts

	.globl	_machdep_sys_select
	
_machdep_sys_select:
	moveal sp,a0
	movel #93,d0
	moveml d2-d6,sp@-
	movel a0@(4),d1
	movel a0@(8),d2
	movel a0@(12),d3
	movel a0@(16),d4
	movel a0@(20),d5
	movel a0@(24),d6
	.byte 0x4e
	.byte 0x44
	bcc _machdep_no_error
	bsr _machdep_error
	moveml sp@+,d2-d6
	rts

	.globl	_machdep_sys_getdirentries
	
_machdep_sys_getdirentries:
	moveal sp,a0
	movel #156,d0
	moveml d2-d6,sp@-
	movel a0@(4),d1
	movel a0@(8),d2
	movel a0@(12),d3
	movel a0@(16),d4
	movel a0@(20),d5
	movel a0@(24),d6
	.byte 0x4e
	.byte 0x44
	bcc _machdep_no_error
	bsr _machdep_error
	moveml sp@+,d2-d6
	rts

	.globl	_machdep_sys_accept
	
_machdep_sys_accept:
	moveal sp,a0
	movel #99,d0
	moveml d2-d6,sp@-
	movel a0@(4),d1
	movel a0@(8),d2
	movel a0@(12),d3
	movel a0@(16),d4
	movel a0@(20),d5
	movel a0@(24),d6
	.byte 0x4e
	.byte 0x44
	bcc _machdep_no_error
	bsr _machdep_error
	moveml sp@+,d2-d6
	rts

	.globl	_machdep_sys_bind
	
_machdep_sys_bind:
	moveal sp,a0
	movel #104,d0
	moveml d2-d6,sp@-
	movel a0@(4),d1
	movel a0@(8),d2
	movel a0@(12),d3
	movel a0@(16),d4
	movel a0@(20),d5
	movel a0@(24),d6
	.byte 0x4e
	.byte 0x44
	bcc _machdep_no_error
	bsr _machdep_error
	moveml sp@+,d2-d6
	rts

	.globl	_machdep_sys_connect
	
_machdep_sys_connect:
	moveal sp,a0
	movel #98,d0
	moveml d2-d6,sp@-
	movel a0@(4),d1
	movel a0@(8),d2
	movel a0@(12),d3
	movel a0@(16),d4
	movel a0@(20),d5
	movel a0@(24),d6
	.byte 0x4e
	.byte 0x44
	bcc _machdep_no_error
	bsr _machdep_error
	moveml sp@+,d2-d6
	rts

	.globl	_machdep_sys_getpeername
	
_machdep_sys_getpeername:
	moveal sp,a0
	movel #141,d0
	moveml d2-d6,sp@-
	movel a0@(4),d1
	movel a0@(8),d2
	movel a0@(12),d3
	movel a0@(16),d4
	movel a0@(20),d5
	movel a0@(24),d6
	.byte 0x4e
	.byte 0x44
	bcc _machdep_no_error
	bsr _machdep_error
	moveml sp@+,d2-d6
	rts

	.globl	_machdep_sys_getsockopt
	
_machdep_sys_getsockopt:
	moveal sp,a0
	movel #118,d0
	moveml d2-d6,sp@-
	movel a0@(4),d1
	movel a0@(8),d2
	movel a0@(12),d3
	movel a0@(16),d4
	movel a0@(20),d5
	movel a0@(24),d6
	.byte 0x4e
	.byte 0x44
	bcc _machdep_no_error
	bsr _machdep_error
	moveml sp@+,d2-d6
	rts

	.globl	_machdep_sys_listen
	
_machdep_sys_listen:
	moveal sp,a0
	movel #106,d0
	moveml d2-d6,sp@-
	movel a0@(4),d1
	movel a0@(8),d2
	movel a0@(12),d3
	movel a0@(16),d4
	movel a0@(20),d5
	movel a0@(24),d6
	.byte 0x4e
	.byte 0x44
	bcc _machdep_no_error
	bsr _machdep_error
	moveml sp@+,d2-d6
	rts

	.globl	_machdep_sys_socket
	
_machdep_sys_socket:
	moveal sp,a0
	movel #97,d0
	moveml d2-d6,sp@-
	movel a0@(4),d1
	movel a0@(8),d2
	movel a0@(12),d3
	movel a0@(16),d4
	movel a0@(20),d5
	movel a0@(24),d6
	.byte 0x4e
	.byte 0x44
	bcc _machdep_no_error
	bsr _machdep_error
	moveml sp@+,d2-d6
	rts

	.globl	_machdep_sys_send
	
_machdep_sys_send:
	moveal sp,a0
	movel #101,d0
	moveml d2-d6,sp@-
	movel a0@(4),d1
	movel a0@(8),d2
	movel a0@(12),d3
	movel a0@(16),d4
	movel a0@(20),d5
	movel a0@(24),d6
	.byte 0x4e
	.byte 0x44
	bcc _machdep_no_error
	bsr _machdep_error
	moveml sp@+,d2-d6
	rts

	.globl	_machdep_sys_sendto
	
_machdep_sys_sendto:
	moveal sp,a0
	movel #133,d0
	moveml d2-d6,sp@-
	movel a0@(4),d1
	movel a0@(8),d2
	movel a0@(12),d3
	movel a0@(16),d4
	movel a0@(20),d5
	movel a0@(24),d6
	.byte 0x4e
	.byte 0x44
	bcc _machdep_no_error
	bsr _machdep_error
	moveml sp@+,d2-d6
	rts

	.globl	_machdep_sys_recv
	
_machdep_sys_recv:
	moveal sp,a0
	movel #102,d0
	moveml d2-d6,sp@-
	movel a0@(4),d1
	movel a0@(8),d2
	movel a0@(12),d3
	movel a0@(16),d4
	movel a0@(20),d5
	movel a0@(24),d6
	.byte 0x4e
	.byte 0x44
	bcc _machdep_no_error
	bsr _machdep_error
	moveml sp@+,d2-d6
	rts

	.globl	_machdep_sys_recvfrom
	
_machdep_sys_recvfrom:
	moveal sp,a0
	movel #125,d0
	moveml d2-d6,sp@-
	movel a0@(4),d1
	movel a0@(8),d2
	movel a0@(12),d3
	movel a0@(16),d4
	movel a0@(20),d5
	movel a0@(24),d6
	.byte 0x4e
	.byte 0x44
	bcc _machdep_no_error
	bsr _machdep_error
	moveml sp@+,d2-d6
	rts

	.globl	_machdep_sys_setsockopt
	
_machdep_sys_setsockopt:
	moveal sp,a0
	movel #105,d0
	moveml d2-d6,sp@-
	movel a0@(4),d1
	movel a0@(8),d2
	movel a0@(12),d3
	movel a0@(16),d4
	movel a0@(20),d5
	movel a0@(24),d6
	.byte 0x4e
	.byte 0x44
	bcc _machdep_no_error
	bsr _machdep_error
	moveml sp@+,d2-d6
	rts

	.globl	_machdep_sys_ioctl
	
_machdep_sys_ioctl:
	moveal sp,a0
	movel #54,d0
	moveml d2-d6,sp@-
	movel a0@(4),d1
	movel a0@(8),d2
	movel a0@(12),d3
	movel a0@(16),d4
	movel a0@(20),d5
	movel a0@(24),d6
	.byte 0x4e
	.byte 0x44
	bcc _machdep_no_error
	bsr _machdep_error
	moveml sp@+,d2-d6
	rts

	.globl	_machdep_sys_socketpair
	
_machdep_sys_socketpair:
	moveal sp,a0
	movel #135,d0
	moveml d2-d6,sp@-
	movel a0@(4),d1
	movel a0@(8),d2
	movel a0@(12),d3
	movel a0@(16),d4
	movel a0@(20),d5
	movel a0@(24),d6
	.byte 0x4e
	.byte 0x44
	bcc _machdep_no_error
	bsr _machdep_error
	moveml sp@+,d2-d6
	rts

	.globl	_machdep_sys_ftruncate
	
_machdep_sys_ftruncate:
	moveal sp,a0
	movel #130,d0
	moveml d2-d6,sp@-
	movel a0@(4),d1
	movel a0@(8),d2
	movel a0@(12),d3
	movel a0@(16),d4
	movel a0@(20),d5
	movel a0@(24),d6
	.byte 0x4e
	.byte 0x44
	bcc _machdep_no_error
	bsr _machdep_error
	moveml sp@+,d2-d6
	rts

	.globl	_machdep_sys_gettimeofday
	
_machdep_sys_gettimeofday:
	moveal sp,a0
	movel #116,d0
	moveml d2-d6,sp@-
	movel a0@(4),d1
	movel a0@(8),d2
	movel a0@(12),d3
	movel a0@(16),d4
	movel a0@(20),d5
	movel a0@(24),d6
	.byte 0x4e
	.byte 0x44
	bcc _machdep_no_error
	bsr _machdep_error
	moveml sp@+,d2-d6
	rts

	.globl	_machdep_sys_wait4
	
_machdep_sys_wait4:
	moveal sp,a0
	movel #7,d0
	moveml d2-d6,sp@-
	movel a0@(4),d1
	movel a0@(8),d2
	movel a0@(12),d3
	movel a0@(16),d4
	movel a0@(20),d5
	movel a0@(24),d6
	.byte 0x4e
	.byte 0x44
	bcc _machdep_no_error
	bsr _machdep_error
	moveml sp@+,d2-d6
	rts

	.globl	_machdep_sys_sigpause
	
_machdep_sys_sigpause:
	moveal sp,a0
	movel #111,d0
	moveml d2-d6,sp@-
	movel a0@(4),d1
	movel a0@(8),d2
	movel a0@(12),d3
	movel a0@(16),d4
	movel a0@(20),d5
	movel a0@(24),d6
	.byte 0x4e
	.byte 0x44
	bcc _machdep_no_error
	bsr _machdep_error
	moveml sp@+,d2-d6
	rts

	.globl	_machdep_sys_getsockname
	
_machdep_sys_getsockname:
	moveal sp,a0
	movel #150,d0
	moveml d2-d6,sp@-
	movel a0@(4),d1
	movel a0@(8),d2
	movel a0@(12),d3
	movel a0@(16),d4
	movel a0@(20),d5
	movel a0@(24),d6
	.byte 0x4e
	.byte 0x44
	bcc _machdep_no_error
	bsr _machdep_error
	moveml sp@+,d2-d6
	rts

	.globl	_machdep_sys_getdtablesize
	
_machdep_sys_getdtablesize:
	moveal sp,a0
	movel #89,d0
	moveml d2-d6,sp@-
	movel a0@(4),d1
	movel a0@(8),d2
	movel a0@(12),d3
	movel a0@(16),d4
	movel a0@(20),d5
	movel a0@(24),d6
	.byte 0x4e
	.byte 0x44
	bcc _machdep_no_error
	bsr _machdep_error
	moveml sp@+,d2-d6
	rts

	.globl	_machdep_sys_lstat
	
_machdep_sys_lstat:
	moveal sp,a0
	movel #40,d0
	moveml d2-d6,sp@-
	movel a0@(4),d1
	movel a0@(8),d2
	movel a0@(12),d3
	movel a0@(16),d4
	movel a0@(20),d5
	movel a0@(24),d6
	.byte 0x4e
	.byte 0x44
	bcc _machdep_no_error
	bsr _machdep_error
	moveml sp@+,d2-d6
	rts





