/* ==== syscall.S ============================================================
 * Based on the freebsd version written by Chris Provenzo
 * Copyright (c) 1990 The Regents of the University of California.
 * Copyright (c) 1995 Chris Provenzano, proven@mit.edu
 *
 * Modified by Herve Avril, for NEXTSTEP
 * Copyright (c) 1996 Hutchison Avenue Software, herve@hasc.ca
 *
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the University of
 *	California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * Description : Machine dependent syscalls for i386/i486/i586
 *
 * syscall-i386-nextstep3.S, v1.0a, January 1996
 *
 */

#ifndef lint
	.text
	.asciz "syscall-i386-nextstep3, v1.0a January 1996";
#endif
 
#if defined(SYSLIBC_SCCS) && !defined(lint)
        .asciz "@(#)syscall.s   5.1 (Berkeley) 4/23/90"
#endif /* SYSLIBC_SCCS and not lint */

#include <bsd/syscall.h> 

#define	SYSCALL(x) \
	.globl _machdep_sys_##x##;		\
						\
_machdep_sys_##x##:				\
						\
	movl	$(SYS_##x##),%eax	;	\
	lcall	$0x2b,$0x0	;		\
	movl	(%esp,1),%edx	;		\
	jb	_machdep_error	;		\
	ret;							

/*
 * Initial asm stuff for all functions.
 */
	.text
	.align	2


/* ==========================================================================
 * error code for all syscalls. The error value is returned as the negative
 * of the errno value.
 */

_machdep_error:
	movl	%eax,_errno
	neg	%eax
	ret

/*
 * machdep_sys_gettimeofday()
 * Note: The timezone argument is ignored on the NeXT computer.
 */
	
	.globl _machdep_sys_gettimeofday; 
	
_machdep_sys_gettimeofday:;
	movl	$(SYS_gettimeofday),%eax
	lcall	$0x2b,$0x0
	movl	(%esp,1),%edx
	jb	_machdep_error	
	ret

	











